Subject: Re: bug#78910: tail does not support -r added by POSIX.1-2024

From: Eric Blake <[email-masked]>
Date: Tue, 1 Jul 2025 14:33:18 -0500

On Tue, Jul 01, 2025 at 02:28:48PM -0500, Eric Blake wrote:
> On Fri, Jun 27, 2025 at 08:51:10AM -0700, Jim Meyering wrote:
> > > >
> > > > [1] https://pubs.opengroup.org/onlinepubs/9799919799/utilities/tail.html
> > >
> > > tail -r comes from the BSDs.
> > > Also the BSDs don't have tac(1) which overlaps in functionality quite a bit.
> > > I'm a bit surprised -r was added by POSIX, but fair enough.
> > 
> > "Surprised" is putting it lightly. I am disappointed and am tempted to
> > push back and to delay encumbering GNU tail with -r.
> > That is an option no GNU system needs, since they've all had tac since
> > before 1992-era textutils.
> > 
> > I've Cc'd Eric Blake, in case someone wants to propose adding tac to
> > POSIX in spite of the fact that the BSDs still lack it.
> 
> I'll bring up this topic at the next Austin Group meeting.
> 
> At any rate, it looks like tail -r was added due to this bug report in
> 2014 (sadly, it is no longer an option to ask Jorg Schilling why he
> wanted it standardized)
> https://www.austingroupbugs.net/view.php?id=877
> 
> But I did ask at the time (with no answer) why we went with 'tail -r'
> instead of 'tac'.

Correction - my comment asking why we didn't go with tac was dated
2014-10-23 at 22:44,
https://www.austingroupbugs.net/view.php?id=877#c2428

but the wording to move forward with 'tail -r' was amended in place,
so even though the proposed wording was in place before my question at
2014-10-23 15:18, it was later amended on 2014-10-30 to add the
Rationale on why 'tail -r' provides a potential algorithmic
improvement over 'tac | head -n' when it comes to amount of memory
consumed.
https://www.austingroupbugs.net/view.php?id=877#c2425

-- 
Eric Blake, Principal Software Engineer
Red Hat, Inc.
Virtualization:  qemu.org | libguestfs.org